var docapture = false;
var capturedata = new Array();
$(document).ready(function(){
	$("#wcpreview").webcam({
		width:360,
		height:270,
		mode:"callback",
		swffile:"/mirror/jquery.webcam/jscam_canvas_only.swf",
		onLoad:function(){
			$("#wcpreview").prepend('<div style="height:270px; z-index:9000; width:360px; margin-bottom:-270px; position:relative; background:url(overlay270.png) no-repeat center center; display:none;" id="wcoverlay"></div>');
		},debug:function(t,s){
			if (s == "Camera started"){
				setTimeout(function(){
					$("#wcoverlay").css("display","block");
					$("#debug").css("display","none").html("");
					$("#analyzebutton").css("display","");
				},400);
			} else if (s == "No camera was detected."){
				$("#debug").html("No webcam detected. Uh-oh.");				
			} else {
				//alert(s);
			}
		},onCapture:function(){
			webcam.save();
		},onSave:function(data){
			capturedata[capturedata.length] = data.split(";");
			if (capturedata.length == 240){
				analyze();
			}
		}
	});
	
	$("#analyzebutton").mousedown(function(){
	//	$(this).css("background","url(/mirror/analyzedown.png) no-repeat center center");
	}).mouseup(function(){
		$(this).css("background","url(/mirror/analyzeup.png) no-repeat center center");
	}).click(function(){
		docapture=true;
		webcam.capture(0);
		$(".s1").css("display","none");
		$(".s2").fadeIn(1000);
	});
		
});

function analyze(){
	
	//Define Functions	
	function rgbdistance(a,b){
		return Math.sqrt(Math.pow(a[0]-b[0],2)+Math.pow(a[1]-b[1],2)+Math.pow(a[2]-b[2],2));
	}
	function rgb2hsl(a){
		var r = a[0]/255, g = a[1]/255, b = a[2]/255;
		var maxcolor = Math.max(Math.max(r,g),b), mincolor = Math.min(Math.min(r,g),b);
		var lum = (maxcolor + mincolor)/2;
		if (r==g && g==b){
			var sat = 0, hue = 0;
		} else {
			if (lum < 0.5){
				var sat = (maxcolor-mincolor)/(maxcolor+mincolor);
			} else {
				var sat = (maxcolor-mincolor)/(2.0-maxcolor-mincolor);
			}
			if (maxcolor == r){
				var hue = (g-b)/(maxcolor-mincolor);
			} else if (maxcolor == g){
				var hue = 2.0 + (b-r)/(maxcolor-mincolor);
			} else if (maxcolor == b){
				var hue = 4.0 + (r-g)/(maxcolor-mincolor);
			}
		}
		
		hue *= 60
		if (hue < 0){
			hue += 360;
		}
		//hue, sat, lum
		//0-366, 0-1, 0-1
		
		return [hue,sat,lum];
	}
	function pixel2rgb(a){
		var r = Math.floor(a/65536);
		var g = Math.floor((a-(65536*r))/256);
		return [r,g,a-(65536*r)-(256*g)];
	}
	function rgb2pixel(a){
		return r*65536+g*256+b;
	}
	function rgbaverage(a){
		var rr=rg=rb=0;
		for (var i=0;i<a.length;i++){
			rr+=a[i][0];
			rg+=a[i][1];
			rb+=a[i][2];
		}
		return [rr/a.length,rg/a.length,rb/a.length];
	}
	function gethue(a){
		return a[0];
	}
	function getsat(a){
		return a[1];
	}
	function getlum(a){
		return a[2];
	}
	function getred(a){
		return a[0];
	}
	function getgreen(a){
		return a[1];
	}
	function getblue(a){
		return a[2];
	}
	
	function coordinatelist(s){
		this.cl = (s==null)?[]:s;
		this.add = function(a,b){
			if (this.contains(a,b)){
				return false;
			} else {
				this.cl[this.cl.length] = [a,b];
				return true;
			}
		}
		this.remove = function (n){
			var ret = [];
			for (var i=0;i<this.cl.length;i++){
				if (i != n){
					ret[ret.length] = [this.cl[i][0],this.cl[i][1]];
				}
			}
			this.cl = ret;
		}
		this.contains = function(x,y){
			for (var i=0;i<this.cl.length;i++){
				var coord = this.cl[i];
				if (coord[0] == x && coord[1] == y){
					return true;
				}
			}
			return false;
		}
		this.clone = function(){
			var ret = [];
			for (var i=0;i<this.cl.length;i++){
				ret[ret.length] = [this.cl[i][0],this.cl[i][1]];
			}
			return new coordinatelist(ret);
		}
		this.get = function(c){
			return this.cl[c];
		}
		this.length = this.cl.length;
		return true;
	}
	Array.prototype.average = function(){
		var ttl = 0;
		for (var i=0;i<this.length;i++){
			ttl+=this[i];
		}
		return ttl/this.length;
	}
	var months = ["January","February","March","April","May","June","July","August","September","October","November","December"];
	$("#analysis").val("theMagicMirror Analysis Record\n"+months[new Date().getMonth()]+" "+new Date().getDay()+" "+new Date().getFullYear() + "\n----------------\n\n");
	function rec(a){
		$("#analysis").val($("#analysis").val() + a);
	}
	
	//Right eye
	var rightpupil = new coordinatelist();
	for (var y=111;y<125;y++){
		for (var x=112;x<144;x++){
			if (rgbdistance(pixel2rgb(capturedata[y][x]),[0,0,0]) < 150){
				rightpupil.add(x,y);
			}
		}
	}
	/*
	var rightpupiltotalx,rightpupiltotaly,rightpupilaverage,rightpupilsquaretotal,rightpupilstddev;
	var rightpupil2 = rightpupil.clone();


	rightpupiltotalx = 0;
	rightpupiltotaly = 0;
	for (var i=0;i<rightpupil2.length;i++){
		rightpupiltotalx += rightpupil2.get(i)[0];
		rightpupiltotaly += rightpupil2.get(i)[1];
	}
	
	rightpupilaverage = [rightpupiltotalx/rightpupil2.length,rightpupiltotaly/rightpupil2.length];
	rightpupilsquaretotal = [0,0];
	
	for (var i=0;i<rightpupil2.length;i++){
		rightpupilsquaretotal[0] += Math.pow(rightpupil2.get(i)[0] - rightpupilaverage[0],2);
		rightpupilsquaretotal[1] += Math.pow(rightpupil2.get(i)[1] - rightpupilaverage[1],2);
	}
	
	rightpupilstddev = [Math.sqrt(rightpupilsquaretotal[0]/(rightpupil2.length-1)),Math.sqrt(rightpupilsquaretotal[1]/(rightpupil2.length-1))];
	
	for (var i=0;i<rightpupil2.length;i++){
		if (Math.abs(rightpupil2.get(i)[0] - rightpupilaverage[0]) > 2*rightpupilstddev[0] || 
			Math.abs(rightpupil2.get(i)[1] - rightpupilaverage[1]) > 2*rightpupilstddev[1] ){
			rightpupil2.remove(i);
			i--;
		}
	}*/
	
	//Left eye
	var leftpupil = new coordinatelist();
	for (var y=111;y<125;y++){
		for (var x=180;x<211;x++){
			if (rgbdistance(pixel2rgb(capturedata[y][x]),[0,0,0]) < 150){
				leftpupil.add(x,y);
			}
		}
	}

	//Skin Tone
	
	var skinsamplesleft = [capturedata[133][111],
						capturedata[154][119],
						capturedata[205][143]];
	
	var skinsamplesright = [capturedata[133][213],
						capturedata[154][205],
						capturedata[205][180]];
	var skinrgbleft = [];
	var skinrgbright = [];
	var skindistanceleft = 0;
	var skindistanceright = 0;
	for (var i=0;i<skinsamplesleft.length;i++){
		for (var j=i;j<skinsamplesleft.length;j++){
			skindistanceleft += Math.pow(rgbdistance(pixel2rgb(skinsamplesleft[i]),pixel2rgb(skinsamplesleft[j])),2);
		}
		skinrgbleft[skinrgbleft.length] = pixel2rgb(skinsamplesleft[i]);
	}
	for (var i=0;i<skinsamplesright.length;i++){
		for (var j=i;j<skinsamplesright.length;j++){
			skindistanceright += Math.pow(rgbdistance(pixel2rgb(skinsamplesright[i]),pixel2rgb(skinsamplesright[j])),2);
		}
		skinrgbright[skinrgbright.length] = pixel2rgb(skinsamplesright[i]);
	}
	var skinaverageleft = rgbaverage(skinrgbleft);
	var skinaverageright = rgbaverage(skinrgbright);
	
	//green-reach algorithm
	var score_greenreach = [];
	
	var greenreachpointsbad = new coordinatelist();
	var greenreachpointsok = new coordinatelist();
	function greenreach(x,y){
		if (x >= 156){
			return greenreachright(x,y);
		} else {
			return greenreachleft(x,y);
		}
	}
	function greenreachleft(x,y){
		return (rgbdistance(skinaverageleft,pixel2rgb(capturedata[y][x])) < 80 && (Math.pow((x-156),2)/5625) + (Math.pow((y-119),2)/10000) < 1 );
	}
	function greenreachright(x,y){
		return (rgbdistance(skinaverageright,pixel2rgb(capturedata[y][x])) < 80 && (Math.pow((x-156),2)/5625) + (Math.pow((y-119),2)/10000) < 1 );
	}
	var slopes = [0.4,0.5,0.6,0.7,0.8,0.9,1.0,1.1,1.3,1.5,1.9,-0.4,-0.5,-0.6,-0.7,-0.8,-0.9,-1.0,-1.1,-1.3,-1.5,-1.9];
	var greenreachresults = [];
	var grdistance = [];
	for (var i=0;i<slopes.length;i++){
		var s = slopes[i];
		var maxerrors = 5;
		var errorssofar = 0;
		var current = 0;
		var grdct = 0;
		
		if (Math.abs(s) < 1){ //x-coordinate based tracking
			current = 156;
			do {
				if (!greenreach(current,Math.round((current-156)*s + 119)) && Math.abs(current - 156) > 40){
					errorssofar++;
					greenreachpointsbad.add(current,Math.round((current-156)*s + 119));
				} else {
					greenreachresults[i] = [current,Math.round((current-156)*s + 119)];
					greenreachpointsok.add(current,Math.round((current-156)*s + 119));					
				}
				if (s > 0){
					current += 1;
				} else {
					current -= 1;
				}
				grdct++;
			} while (errorssofar < maxerrors);
		} else { //y-coordinate based tracking
			current = 119;
			do {
				if (!greenreach(Math.round((current - 119)/s + 156),current) && Math.abs(current - 119) > 40 && (Math.abs(s) < 6 || Math.abs(current-119) > 90)){
					errorssofar++;
					greenreachpointsbad.add(Math.round((current - 119)/s + 156),current);
				} else {
					greenreachresults[i] = [Math.round((current - 119)/s + 156),current];
					greenreachpointsok.add(Math.round((current - 119)/s + 156),current);
				}
				current += 1;
				grdct++;
			} while (errorssofar < maxerrors);			
		}
		
		grdistance[grdistance.length] = grdct;
	}
	for (var i=0;i<grdistance.length;i++){
		if (grdistance[i] < 50){
			rec("Glare detected, grdct = "+grdistance[i]);
		}
	}
	for (var i=0;i<greenreachresults.length - 1;i++){
		rec(((greenreachresults[i][1] - greenreachresults[i+1][1])/(greenreachresults[i][0] - greenreachresults[i+1][0])) + ",");
	}
	/*
	for (var i=0; i<greenreachresults-1; i++){
		if (slopes[i] > 0){ //positive slope, should be neg
			if ((greenreachresults[i+1][1]-greenreachresults[i][1]) / (greenreachresults[i+1][0] - greenreachresults[i][0]) > 0){
				score_greenreach[score_greenreach.length] = -30;
			} else {
				score_greenreach[score_greenreach.length] = 5;
			}
		} else {
			if ((greenreachresults[i+1][1]-greenreachresults[i][1]) / (greenreachresults[i+1][0] - greenreachresults[i][0]) < 0){
				score_greenreach[score_greenreach.length] = -30;
			} else {
				score_greenreach[score_greenreach.length] = 5;
			}			
		}
	}
	rec("Greenreach Score: "+score_greenreach.average());
	*/
	var ctx = document.getElementById("wcpostcanvas").getContext("2d");
	var postimage = ctx.getImageData(0,0,320,240);
	
	var ct = 0;
	for (var i=0;i<240;i++){
		var tmprow = capturedata[i];
		for (var j=0;j<320;j++){
			var tmppixel = parseInt(tmprow[j]);
			if (rightpupil.contains(j,i)){
				postimage.data[4*ct+0] = 0xff;
				postimage.data[4*ct+1] = 0x00;
				postimage.data[4*ct+2] = 0x00;
				postimage.data[4*ct+3] = 0xff;
			} else if (leftpupil.contains(j,i)){
				postimage.data[4*ct+0] = 0x00;
				postimage.data[4*ct+1] = 0x00;
				postimage.data[4*ct+2] = 0xff;
				postimage.data[4*ct+3] = 0xff;	
			//} else if (rgbdistance(skinaverageleft,pixel2rgb(tmppixel)) < 80 && (Math.pow((j-156),2)/5625) + (Math.pow((i-119),2)/10000) < 1 && j < 156){
			} else if (greenreachpointsok.contains(j,i)){
				postimage.data[4*ct+0] = 0x00;
				postimage.data[4*ct+1] = 0xbb;
				postimage.data[4*ct+2] = 0x00;
				postimage.data[4*ct+3] = 0xff;
			//} else if (rgbdistance(skinaverageright,pixel2rgb(tmppixel)) < 80 && (Math.pow((j-156),2)/5625) + (Math.pow((i-119),2)/10000) < 1 && j >= 156){
			} else if (greenreachpointsbad.contains(j,i)){
				postimage.data[4*ct+0] = 0xff;
				postimage.data[4*ct+1] = 0xff;
				postimage.data[4*ct+2] = 0xff;
				postimage.data[4*ct+3] = 0xff;				
			} else {
				postimage.data[4*ct+0] = (tmppixel >> 16) & 0xff;
				postimage.data[4*ct+1] = (tmppixel >> 8) & 0xff;
				postimage.data[4*ct+2] = tmppixel & 0xff;
				postimage.data[4*ct+3] = 0xff;
			}
			ct++;
		}
	}
	ctx.putImageData(postimage,0,0);
	
	setTimeout(function(){
		$("#console").css("background","#fff url(/mirror/results.png) 20px 20px no-repeat");
		$(".s2").fadeOut(500);
	},1001);
	setTimeout(function(){
		$(".s3").fadeIn(500);
	},2000);
}